/*+++*
 *  RCS CNewsConfigPanel.h,v 1.5 1995/07/13 11:47:30 tom Exp
 *  title:	CNewsConfigPanel.h
 *  abstract:	declarations for CNewsConfigPanel class, for NewsConfig.app
 *  author:	T.R.Hageman, Groningen, The Netherlands
 *  created:	December 1994
 *  modified:	(see RCS Log at end)
 *  copyright:
 *
 *		Copyright (C) 1994,1995  Tom R. Hageman.
 *
 *	This is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This software is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this software; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  description:
 *
 *	This implements a window dedicated to presenting the CNews
 *	configuration parameters.
 *
 *	(It acts as the delegate of the active-group browser it contains)
 *
 *	XXX expand.
 *
 *---*/

#import <appkit/appkit.h>

@interface CNewsConfigPanel:Panel
{
    id	activegroups;
    id	addsigMaxlines;
    id	addsignature;
    id	expirermdir;
    id	hostname;
    id	immednews;
    id	newsfeed;
    id	newsfeedSubscriptions;
    id	newsfeedDistribution;
    id	newsfeedFlags;
    id	organization;
    id	uucpname;
    id	negenExtrasBlurb;
    id	activeButtons;
    id	allowNewHierarchies;
    id	okButton;		// so we can disable it if necessary.
	HashTable *table;
}

- revert:sender;
- activeSelected:sender;	// Browser single-click action.
- toggleActive:sender;		// Browser double-click action.
- addSelectionToActive:sender;
- removeSelectionFromActive:sender;

- (void)setConfiguration:(HashTable *)aTable;
- (HashTable *)configuration;

- setEnabled:(BOOL)yn;
- (BOOL)isEnabled;

@end

/*======================================================================
 * CNewsConfigPanel.h,v
 * Revision 1.5  1995/07/13 11:47:30  tom
 * (allowNewHierarchies,okButton): new ivars;
 * (-setEnables:,isEnabled): new methods;
 * [added RCS Id, fix Copyright notice]
 *
 * Revision 1.4  1995/01/13  22:42:15  tom
 * (newsfeedSubscriptions,newsfeedDistribution,newsfeedFlags): new outlets.
 *
 * Revision 1.3  1995/01/09  05:35:54  tom
 * (activeButtons): new outlet; (activeSelected:,addSelectionToActive:,
 *  removeSelectionFromActive:): new action methods.
 *
 * Revision 1.2  1994/12/21  13:54:01  tom
 * (negenExtrasBlurb): new outlet.
 *
 * Revision 1.2  1994/12/21  13:54:01  tom
 * (negenExtrasBlurb): new outlet.
 *
 * Revision 1.1  1994/12/20  01:08:12  tom
 * Initial revision
 *
 *======================================================================*/
