/*+++*
 *  title:	CheckedBrowserCell.h
 *  abstract:	declarations for CheckedBrowserCell class, for NewsConfig.app
 *  author:	T.R.Hageman, Groningen, The Netherlands
 *  created:	January 1995
 *  modified:	(see RCS Log at end)
 *  copyright:
 *
 *		Copyright (C) 1994  Tom R. Hageman.
 *
 *	This is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This software is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this software; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  description:
 *
 *	This is a subclass of BrowserCell that contains a check box.
 *
 *	(it assumes that the images named "check", "checkH", "nocheck"
 *	 and "nocheckH" exist and can be found.)
 *---*/

#import <appkit/appkit.h>


@interface CheckedBrowserCell: NXBrowserCell
{
	BOOL	checked;
}

- (BOOL)checked;
- setChecked:(BOOL)yn;

@end

/*======================================================================
 * CheckedBrowserCell.h,v
 * Revision 1.1  1995/01/10 02:38:50  tom
 * Initial revision
 *
 *======================================================================*/
