/*+++*
 *  RCS Controller.h,v 1.4 1995/07/13 11:37:03 tom Exp
 *  title:	Controller.h
 *  abstract:	declarations for Controller class, for NewsConfig.app
 *  author:	T.R.Hageman, Groningen, The Netherlands
 *  created:	December 1994
 *  modified:	(see RCS Log at end)
 *  copyright:
 *
 *		Copyright (C) 1994,1995  Tom R. Hageman.
 *
 *	This is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This software is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this software; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  description:
 *
 *	This is the Controller of CNewsConfig.
 *
 *	(It acts as the Application's delegate.)
 *
 * 	At startup the shell script "getnewsconf.sh" is called to
 *	provide the default configuration parameters.  These parameters
 *	are stored as (key,value) pairs in a HashTable.  The
 *	configuration is presented to the user in a window of class
 *	CNewsConfigPanel.  An "OK" button press invokes configure: which
 *	calls the shell script "setnewsconf.sh".  The new configuration
 *	is handed to this script as (key,value) pairs on its standard
 *	input.
 *
 *---*/

#import <appkit/appkit.h>

@class CNewsConfigPanel;

@interface Controller:Object
{
#if IB
	id	configPanel;
#else
	CNewsConfigPanel *configPanel;
#endif
	id	infoPanel;
	id	infoVersionField;
}

- configure:sender;
- showInfo:sender;

@end

/*======================================================================
 * Controller.h,v
 * Revision 1.4  1995/07/13 11:37:03  tom
 * (okButton): removed.
 * [added RCS Id, fixed Copyright notice]
 *
 * Revision 1.3  1995/01/09  02:44:04  tom
 * (okButton): new outlet.
 *
 * Revision 1.2  1995/01/04  15:14:18  tom
 * (infoVersionField): new outlet.
 *
 * Revision 1.1  1994/12/20  01:08:12  tom
 * Initial revision
 *
 *======================================================================*/
