extern int slrn_select_group_mode (void);
extern void slrn_group_quit (void);
extern void slrn_select_next_group (void);
extern void slrn_select_prev_group (void);
extern int slrn_read_newsrc (int);
extern int slrn_write_newsrc (void);
extern void slrn_mark_article_as_read (char *, long);
extern void slrn_do_key (SLKeyMap_List_Type *);
extern void slrn_check_new_groups (int);
extern void slrn_init_group_mode (void);
extern void slrn_get_group_descriptions (void);
extern int slrn_read_group_descriptions (void);
extern SLKeyMap_List_Type *Slrn_Group_Keymap;
extern void slrn_post_cmd (void);
extern void slrn_digit_arg (SLKeyMap_List_Type *);
extern void slrn_repeat_last_key (void);
extern char *slrn_current_group (void);
extern void slrn_set_prefix_argument (int);

typedef struct Slrn_Range_Type 
{
   struct Slrn_Range_Type *next;
   struct Slrn_Range_Type *prev;
   int min, max;
} Slrn_Range_Type;

typedef struct Slrn_Group_Type
{
   struct Slrn_Group_Type *next;
   struct Slrn_Group_Type *prev;
#define MAX_GROUP_NAME_LEN 80
   char name[MAX_GROUP_NAME_LEN + 1];
   unsigned long hash;
   struct Slrn_Group_Type *hash_next;
   unsigned int flags;
#define GROUP_UNSUBSCRIBED	0x1
#define GROUP_HIDDEN		0x2
#define GROUP_TOUCHED		0x4
#define GROUP_NEW_GROUP_FLAG	0x8
#define GROUP_PROCESSED		0x100
   
   Slrn_Range_Type range;		       /* the first range corresponds to
						* what the server has.  next ranges
						* correspond to what has been read.
						*/
   int unread;
   char *descript;		       /* description of the group */
}
Slrn_Group_Type;

/* See important comment in group.c about this. */
extern void slrn_add_group_ranges (Slrn_Group_Type *, int, int);

extern int Slrn_Groups_Dirty;
extern int Slrn_Group_Window_Size;
extern int Slrn_Group_Display_Descriptions;
extern int Slrn_Group_Description_Column;
extern int *Slrn_Prefix_Arg_Ptr;
extern int Slrn_No_Backups;
extern int Slrn_Unsubscribe_New_Groups;
extern int Slrn_List_Active_File;
extern int Slrn_Query_Group_Cutoff;
extern int Slrn_Prompt_Next_Group;
extern int Slrn_Use_Xgtitle;
extern int Slrn_Write_Newsrc_Flags;
