#ifndef _SLRN_SLRN_H_
#define _SLRN_SLRN_H_
#define SLRN_VERSION "0.9.0.0 (BETA)"
extern char *Slrn_Version;

extern int Slrn_TT_Initialized;
extern void slrn_exit_error (char *, ...);
extern void slrn_tty_message (int, char *, ...);
extern void slrn_quit (int);

extern void slrn_init_display (int, int);
extern void slrn_reset_display (int);
extern void slrn_suspend (int);
extern int  slrn_get_new_news (int, int);
extern char *Slrn_Newsrc_File;
#if 0
extern void (*Slrn_Hangup_Hook) (int);
extern void (*Slrn_Winch_Function) (void);
#endif

typedef struct
{
   SLKeyMap_List_Type *keymap;
   void (*redraw_fun) (void);
   void (*sigwinch_fun) (void);
   void (*hangup_fun) (int);
#define SLRN_ARTICLE_MODE	1
#define SLRN_GROUP_MODE		2
   int mode;
}
Slrn_Mode_Type;

Slrn_Mode_Type *Slrn_Current_Mode;

extern int slrn_main_loop (void);

extern int slrn_parse_helpfile (char *);
extern void slrn_smg_refresh (void);
extern void slrn_set_suspension (int);
extern void slrn_enable_mouse (int);
extern void slrn_init_hangup_signals (int);
extern int Slrn_Suspension_Ok;
extern int Slrn_Use_Mouse;

extern char *Slrn_Lib_Dir;
extern char *Slrn_Current_Group_Name;

#define HEADER_COLOR	1
#define GROUP_COLOR	2
#define SUBJECT_COLOR	3
#define AUTHOR_COLOR	4
#define ERROR_COLOR	5
#define CURSOR_COLOR	6
#define ARTICLE_COLOR	7
#define TREE_COLOR	8
#define QUOTE_COLOR	9
#define SIGNATURE_COLOR 10
#define THREAD_NUM_COLOR 11
#define HIGH_SCORE_COLOR 12
#define MENU_PRESS_COLOR 13
#define HEADER_NUMBER_COLOR 14
#define GROUP_DESCR_COLOR 15
#define GROUPLENS_DISPLAY_COLOR 16
#define SLRN_TILDE_COLOR	17

/* Colors below here are inverse video on B+W terminals. */
#define STATUS_COLOR	20
#define MENU_COLOR	21

#endif				       /* _SLRN_SLRN_H_ */
